/*******************************************************************

Part of the Fritzing project - http://fritzing.org
Copyright (c) 2007-2009 Fachhochschule Potsdam - http://fh-potsdam.de

Fritzing is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Fritzing is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Fritzing.  If not, see <http://www.gnu.org/licenses/>.

********************************************************************

$Revision: 2407 $:
$Author: cohen@irascible.com $:
$Date: 2009-02-17 16:06:14 +0100 (Tue, 17 Feb 2009) $

********************************************************************/

#ifndef BUS_H
#define BUS_H

#include <QString>
#include <QDomElement>
#include <QHash>
#include <QList>
#include <QXmlStreamWriter>
#include <QGraphicsScene>

class Bus {
	
public:
	Bus(class BusShared *, class ModelPart *);
	
	const QString & id();
	const QList<class Connector *> & connectors();
	void addViewItem(class ConnectorItem *);
	void removeViewItem(class ConnectorItem *);
	void addConnector(class Connector *);
	class Connector * busConnector();
	class ModelPart * modelPart();
	//ConnectorItem * connectorItem(QGraphicsScene * scene);
	
public:
	static QHash<QString, class Bus *> ___emptyBusList___;

	
protected:

	QList<class ConnectorItem *> m_connectorItems;
	QList<class Connector *> m_connectors;
	BusShared * m_busShared;
	class Connector * m_busConnector;
	class ModelPart * m_modelPart;
};


#endif
