/*******************************************************************

Part of the Fritzing project - http://fritzing.org
Copyright (c) 2007-2009 Fachhochschule Potsdam - http://fh-potsdam.de

Fritzing is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Fritzing is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Fritzing.  If not, see <http://www.gnu.org/licenses/>.

********************************************************************

$Revision: 2820 $:
$Author: cohen@irascible.com $:
$Date: 2009-04-15 16:37:21 +0200 (Wed, 15 Apr 2009) $

********************************************************************/

#ifndef SKETCHMODEL_H
#define SKETCHMODEL_H

#include "modelpart.h"
#include "modelbase.h"

#include <QTextStream>
#include <QMultiHash>

class SketchModel : public ModelBase
{

public:
	SketchModel(bool makeRoot);
	SketchModel(ModelPart * root);

	void removeModelPart(ModelPart *);
	ModelPart * findModelPart(const QString & moduleID, long id);
	bool paste(ModelBase * refModel, const QString & filePath, QList<ModelPart *> & modelParts, QHash<QList<long> *, QString> * externalConnectors);
	void walk(ModelPart *, int indent);
	ModelPartTiny * makeTiny(ModelPart * modelPart);
	ModelPart * findModelPartFromOriginal(ModelPart * parent, long originalModelIndex);

protected:
	ModelPart * findModelPartAux(ModelPart * modelPart, const QString & moduleID, long id);
};

#endif
